% coulomb potential band structure

n = 5;
s = 0.01;

init(n);

G = [0;0;0];
X = [1;0;0];
L = [1/2;1/2;1/2];
K = [3/4;0;3/4];
U = [1;1/4;1/4];
W = [1;0;1/2];

v = 0;
x = [];
y = [];
Lx = 0;

[n,k,e] = part(L,G,s); x = [x;k+v]; y = [y;e]; v = v+n; G1x = v;
[n,k,e] = part(G,X,s); x = [x;k+v]; y = [y;e]; v = v+n; Xx = v;
[n,k,e] = part(X,U,s); x = [x;k+v]; y = [y;e]; v = v+n; Kx = v;
[n,k,e] = part(K,G,s); x = [x;k+v]; y = [y;e]; v = v+n; G2x = v;
e = energy(G); x = [x;v]; y = [y;e'];

ymin=min(min(y));
ymax=max(max(y));

hold on;
title("Coulombic band structure");
xlabel("k [2π/a]");
ylabel("E [eV]");
plot(x,y,'k');
plot([G1x,G1x],[ymin,ymax],'b');
plot([Xx,Xx],[ymin,ymax],'b');
plot([Kx,Kx],[ymin,ymax],'b');
set (gca,'xtick',[Lx G1x Xx Kx G2x]);
set (gca,'xticklabel',{"L","Γ","X","U,K","Γ"});
axis([0 v ymin ymax/2]);
hold off;

print("band.png");
