function init (n);

  global basis kinconst potconst size cache;

  basis = [-1 1 1; 1 -1 1; 1 1 -1]; % reciprocal basis

  epsilon=8.854187817e-12; % vacuum permittivity [F/m]
  hbar = 6.58211928e-16; % Planck constant [eV]
  c = 2.99792548e8; % speed of light [m/s]
  m = 5.10998910e5; % electron mass [eV/c^2]
  e = 1.602176565e-19; % elementary charge [C]

  a = 5.430710e-10; % silicon lattice spacing [m]
  zeff = 0.5; % effective atomic number []

  kinconst = (pi*hbar*c)^2/(2*m*a^2); % [eV]
  potconst = -zeff*e/(pi^2*epsilon*a); % [eV]

  size = n;

  for i1 = (-size+1):(size-1)
    for i2 = (-size+1):(size+1)
      for i3 = (-size+1):(size+1)
	cache(i1+size,i2+size,i3+size) = potential([i1;i2;i3]);
      end
    end
  end

end
