% optical lattice band structure

v = [0, 5, 10, 20]; % potential

b = 100; % basis size
p = 20; % number of points

g = 2*(-b:b);
k = 1/p*(-p:p);

o0 = ones(2*b+1, 1);
o1 = ones(2*b, 1);

for i = 1:length(v)
  m0 = diag(1/2*o0*v(i)) + diag(-1/4*o1*v(i), 1) + diag(-1/4*o1*v(i), -1);

  o = [];
  for j = k
    m = m0 + diag((g+j).^2);
    d = eig(m);
    o = [o; d(1:6)'];
  end

  subplot(1,length(v),i);
  plot(k,o);
  axis([-1 1 0 30]);

  % E_R = π^2ħ^2/2ma^2
  title(sprintf("V = %d E_R", v(i)));
  xlabel("k [π/a]");
  if i == 1
    ylabel("E [E_R]");
  end
end

print("band.png");
