% optical lattice band structure

v = [0, 5, 10, 20]; % potential

b = 100; % basis size
p = 50; % number of points
q = 5; % number of states

g = 2*(-b:b);
x = 1/(2*p)*(-p:p);
k = 1/q*(-q:q);

c = exp(pi*I*x');

f = [];
for i = 1:length(g)
  f = [f c.^g(i)];
end

o0 = ones(2*b+1, 1);
o1 = ones(2*b, 1);

for i = 1:length(v)
  m0 = diag(1/2*o0*v(i)) + diag(-1/4*o1*v(i), 1) + diag(-1/4*o1*v(i), -1);

  for s = 1:4
    o = [];
    for j = k
      m = m0 + diag((g+j).^2);
      [w,d] = eig(m);
      o = [o abs(f*w(:,s)).^2];
    end
    subplot(length(v),4,4*(i-1)+s);
    plot(x,v(i)*(sin(pi*x)).^2,"k",x,o);
    axis([-1/2 1/2 0 5]);
    if i == length(v)
      xlabel(sprintf("x [a], Band #%d",s));
    end
    if s == 1
      % E_R = π^2ħ^2/2ma^2
      ylabel(sprintf("|ψ(x)|^2, V = %d E_R", v(i)));
    end
  end

end

print("wave.png");
