% optical lattice band structure

d = 5; % optical lattice depth [E_R]

n = 9;
s = 0.01;

init(n,d);

G = [0;0];
X = [1/2;0];
M = [1/2;1/2];

v = 0;
x = [];
y = [];
M1x = 0;

[n,k,e] = part(M,G,s); x = [x;k+v]; y = [y;e]; v = v+n; Gx = v;
[n,k,e] = part(G,X,s); x = [x;k+v]; y = [y;e]; v = v+n; Xx = v;
[n,k,e] = part(X,M,s); x = [x;k+v]; y = [y;e]; v = v+n; M2x = v;
e = energy(M); x = [x;v]; y = [y;e'];

ymin=min(min(y));
ymax=max(max(y));

clf;
hold on;
title(sprintf("2D optical lattice band structure (V = %d E_R)",d));
xlabel("k [2π/a]");
ylabel("E [E_R]");
plot(x,y,'k');
plot([Gx,Gx],[ymin,ymax],'b');
plot([Xx,Xx],[ymin,ymax],'b');
set (gca,'xtick',[M1x Gx Xx M2x]);
set (gca,'xticklabel',{"M","Γ","X","M"});
axis([0 v ymin (ymin+ymax)/2]);
hold off;

print("band.png");
