% optical lattice band structure

d = 5; % optical lattice depth [E_R]

n = 5;
s = 0.01;

init(n,d);

G = [0;0;0];
X = [1/2;0;0];
M = [1/2;1/2;0];
R = [1/2;1/2;1/2];

v = 0;
x = [];
y = [];
M1x = 0;

[n,k,e] = part(M,G,s); x = [x;k+v]; y = [y;e]; v = v+n; Gx = v;
[n,k,e] = part(G,X,s); x = [x;k+v]; y = [y;e]; v = v+n; Xx = v;
[n,k,e] = part(X,R,s); x = [x;k+v]; y = [y;e]; v = v+n; Rx = v;
[n,k,e] = part(R,M,s); x = [x;k+v]; y = [y;e]; v = v+n; M2x = v;
e = energy(M); x = [x;v]; y = [y;e'];

ymin=min(min(y));
ymax=max(max(y));

hold on;
title(sprintf("3D optical lattice band structure (V = %d E_R)",d));
xlabel("k [2π/a]");
ylabel("E [E_R]");
plot(x,y,'k');
plot([Gx,Gx],[ymin,ymax],'b');
plot([Xx,Xx],[ymin,ymax],'b');
plot([Rx,Rx],[ymin,ymax],'b');
set (gca,'xtick',[M1x Gx Xx Rx M2x]);
set (gca,'xticklabel',{"M","Γ","X","R","M"});
axis([0 v ymin (ymin+ymax)/2]);
hold off;

print("band.png");
